﻿###############################################################################
#                      Create Security Group for Office 365                   #
#                             For Secondary Group                             #
#                                  V3.9.8.9                                   #
#                       (C)2006-2022 KoXo Developpement                       #
###############################################################################
.("%LAUNCHING_PATH%\AdminScripts\KoXo-Tools.ps1")
.("%LAUNCHING_PATH%\AdminScripts\KoXo-MSol.ps1")
###############################################################################
#                                    Main                                     #
###############################################################################
$Copyright = "(C)2006-2022 KoXo Developpement"
$Version = "V3.9.8.9"
$Title = "Create security group for Office 365 $($Version)", "$($Copyright)"
# Office 365 params
$Office365LoginName = "%OFFICE365_ADMIN%"
$Office365LoginPassword = [System.Text.Encoding]::ASCII.GetString([System.Convert]::FromBase64String("%OFFICE365_BASE64_PASSWORD%"))
# Proxy parameters
$ProxyEnabled = $#BOOL{%PROXY_ENABLED%}
$ProxyUser = "%PROXY_USER%"     
$ProxyPassword = [System.Text.Encoding]::ASCII.GetString([System.Convert]::FromBase64String("%PROXY_BASE64_PASSWORD%"))
$ProxyUrl = "%PROXY_ADDRESS%"
$ProxyPort = %PROXY_PORT%
# Log filename
$LogFile = $MyInvocation.MyCommand.Definition 
$LogFile = $LogFile -replace(".ps1",".log")
#
$global:total_errors_count = 0
#
banner $Title
check_version
if (import_modules MSOnline) {
    set_proxy $ProxyEnabled $ProxyUrl $ProxyPort $ProxyUser $ProxyPassword
    if ((connect_msol $Office365LoginName $Office365LoginPassword) -eq $true) {
        ### BEGIN_REPETITION ###
        $global:errors_count = 0
        # KoXo Administrator's variables
        $SecurityGroupName = "%SECONDARY_GROUP%"
        $SecurityGroupDescription = "%SECONDARY_GROUP_DESC%"
        $SecurityGroupMembers = "%SECONDARY_GROUP_USERS_EMAIL%"
        log_message "OFFICE365" "$($SecurityGroupName) ($($SecurityGroupDescription))"
        $Group = get_koxo_security_group $SecurityGroupName
        if (![string]::IsNullOrEmpty($Group)) {
            modify_security_group $SecurityGroupName $SecurityGroupDescription $SecurityGroupMembers
        }
        else {
            create_security_group $SecurityGroupName $SecurityGroupDescription $SecurityGroupMembers
        }
        log_errors_count $DistributionGroupName
        $global:total_errors_count = $global:total_errors_count + $global:errors_count
        ### END_REPETITION ###    
    }
    else {
        $global:total_errors_count++
        $S = "Unable to connect to MSOnline !"
        Write-Host $S -Foregroundcolor "Red"
        Log_Message "ERROR" $S
    }
}
else {
    $global:total_errors_count++
    $S = "ExchangeOnlineManagement Powershell module cannot be loaded !"
    Write-Host $S -Foregroundcolor "Red"
    Log_Message "ERROR" $S
}
log_total_errors_count