﻿###############################################################################
#                      Delete a team for Microsoft Teams                      #
#                                    V3.9.8.9                                 #
#                       (C)2006-2022 KoXo Developpement                       #
###############################################################################
.("%LAUNCHING_PATH%\AdminScripts\KoXo-Tools.ps1")
.("%LAUNCHING_PATH%\AdminScripts\KoXo-Teams.ps1")
###############################################################################
#                                    Main                                     #
###############################################################################
$Copyright = "(C)2006-2022 KoXo Developpement"
$Version = "V3.9.8.9"
$Title = "Delete a team for Microsoft Teams $($Version)", "$($Copyright)"
# Office 365 params
$Office365LoginName = "%OFFICE365_ADMIN%"
$Office365LoginPassword = [System.Text.Encoding]::ASCII.GetString([System.Convert]::FromBase64String("%OFFICE365_BASE64_PASSWORD%"))
# Proxy parameters
$ProxyEnabled = $#BOOL{%PROXY_ENABLED%}
$ProxyUser = "%PROXY_USER%"     
$ProxyPassword = [System.Text.Encoding]::ASCII.GetString([System.Convert]::FromBase64String("%PROXY_BASE64_PASSWORD%"))
$ProxyUrl = "%PROXY_ADDRESS%"
$ProxyPort = %PROXY_PORT%
# Log filename
$LogFile = $MyInvocation.MyCommand.Definition 
$LogFile = $LogFile -replace(".ps1",".log")
#
$global:total_errors_count = 0
$global:total_warnings_count = 0
#
banner $Title
check_version
if (import_modules MicrosoftTeams) {
    set_proxy $ProxyEnabled $ProxyUrl $ProxyPort $ProxyUser $ProxyPassword
    if ((connect_teams $Office365LoginName $Office365LoginPassword) -eq $true) {
        ### BEGIN_REPETITION ###
        $global:errors_count = 0
        $SecondaryGroupDisplayName = "%SECONDARY_GROUP_TEAMS_DISPLAY_NAME%"
        $SecondaryGroup = "%SECONDARYGROUP%"
        $MailNickName = -Join ("teams-", $SecondaryGroup.ToLower())
        team_remove $MailNickName
        log_errors_count $SecondaryGroupDisplayName
        $global:total_errors_count = $global:total_errors_count + $global:errors_count
        ### END_REPETITION ###
		Disconnect-MicrosoftTeams -Confirm:$false
    }
    else {
        $global:total_errors_count++
        $S = "Unable to connect to Microsoft Teams !"
        Write-Host $S -Foregroundcolor "Red"
        Log_Message "ERROR" $S
    }
}
else {
    $global:total_errors_count++
    $S = "MicrosoftTeams Powershell module cannot be loaded !"
    Write-Host $S -Foregroundcolor "Red"
    Log_Message "ERROR" $S
}
log_total_errors_count
log_total_warnings_count